<?php

namespace WobbleCode\UserBundle\Validator\Constraints;

use Symfony\Component\Validator\Constraint;
use Symfony\Component\Validator\ConstraintValidator;

class NotAnonymousEmailValidator extends ConstraintValidator
{
    protected $invalidDomains = [
        'figjs\.com',
        '10mail\.org',
        'yomail\.info',
        'dropmail\.me',
        'msgos\.com',
        'vmani\.com',
        'swift10minutemail\.com',
        'mailbox.+\.biz$',
        'imgof\.com$',
        'yopmail\.com$',
        'armyspy\.com$',
        'cuvox\.de$',
        'dayrep\.com$',
        'einrot\.com$',
        'fleckens\.hu$',
        'gustr\.com$',
        'jourrapide\.com$',
        'rhyta\.com$',
        'superrito\.com$',
        'teleworm\.us$',
        'trbvm\.com$',
        'trbvn\.com$',
        'iaoss\.com$',
        'maildrop\.cc$',
        'mailinator\.com$',
        'harakirimail\.com$',
        'dispostable\.com$',
        'ce\.mintemail\.com$',
        'mailnull\.com$',
        'meltmail\.com$',
        'mailforspam\.com$',
        'mfsa\.ru$',
        'tmail\.ws$',
        'moakt\.com$',
        'imgv\.de$',
        'bouncr\.com$',
        '33mail\.com$',
        'SharedMailbox\.org$',
        'InboxProxy\.com$',
        'Dacoolest\.com$',
        'EmailProxsy\.com$',
        'MailProxsy\.com$',
        'ThrowawayEmailAddress\.com$',
        'discard\.email$',
        'discardmail\.com$',
        'discardmail\.de$',
        'spambog\.com$',
        'spambog\.de$',
        'spambog\.ru$',
        'cachedot\.net$',
        '0815\.ru$',
        'hulapla\.de$',
        's0ny\.net$',
        'teewars\.org$',
        'yapped\.net$',
        'spamstack\.net$',
        'freundin\.ru$',
        'pfui\.ru$',
        '0815\.su$',
        'sweetxxx\.de$',
        'fiifke\.de$',
        'showslow\.de$',
        'jobbikszimpatizans\.hu$',
        'azazazatashkent\.tk$',
        'anotherdomaincyka\.tk$',
        'ckaazaza\.tk$',
        'dasdasdascyka\.tk$',
        'lolito\.tk$',
        'regspaces\.tk$',
        'vaasfc4\.tk$',
        'wfgdfhj\.tk$',
        'xy9ce\.tk$',
        'eqeqeqeqe\.tk$',
        'vihost\.tk$',
        'sdfghyj\.tk$',
        'vickaentb\.tk$',
        'wasdfgh\.gq$',
        'wasdfgh\.tk$',
        'inmynetwork\.gq$',
        'inmynetwork\.tk$',
        'zeta-telecom\.com$',
        'ebano\.campano\.cl$',
        'gaf\.oseanografi\.id$',
        'box\.yadavnaresh\.com\.np$',
        'my\.vondata\.com\.ar$',
        'axe\.axeprim\.eu$',
        'zaktouni\.fr$',
        '2-ch\.space$',
        'web-emailbox\.eu$',
        'freelance-france\.eu$',
        'webcontact-france\.eu$',
        'fast-mail\.fr$',
        'mail-easy\.fr$',
        'instantmail\.fr$',
        'cnn\.coms\.hk$',
        'fbi\.coms\.hk$',
        'visa\.coms\.hk$',
        'nike\.coms\.hk$',
        'pepsi\.coms\.hk$',
        'drama\.tw$',
        'mail1\.kein\.hk$',
        'mail1\.kaohsiung\.tv$',
        'mail1\.ismoke\.hk$',
        'mail1\.i-taiwan\.tv$',
        'mail1\.hacked\.jp$',
        'mail2\.worksmobile\.ml$',
        'zmail\.info\.tm$',
        'mail2\.info\.tm$',
        'abcz\.info\.tm$',
        '2ch\.orgs\.hk$',
        '2ch\.coms\.hk$',
        'web-contact\.info$',
        'immo-gerance\.info$',
        'je-recycle\.info$',
        'vrsim\.ir$',
        'stophabbos\.tk$',
        'dfghj\.ml$',
        'klammlose\.org$',
        'skrx\.tk$',
        'sraka\.xyz$',
        'goofy1\.com$',
        'h0mie\.tk$',
        'habbojue\.ga$',
        'servermaps\.net$',
        'mynetwork\.cf$',
        'vihost\.ml$',
        'vickaentb\..+$',
        'wasdfgh\..+$',
        'inmynetwork\..+$',
        'ts-by-tashkent\..+$',
        'lolitka\.cf$',
        'labetteraverouge\.at$',
        'kurzepost\.de$',
        'objectmail\.com$',
        'rcpt\.at$',
        'trash-mail\..+$',
        'trashmail\..+$',
        'proxymail\.eu$',
        'wegwerfmail\.de$',
        'dispostable\.com$',
        'dropmail\.me$',
        'yomail\.info$',
        'mail\.org$',
    ];

    public function validate($value, Constraint $constraint)
    {
        $domainsRegexp = implode('|', $this->invalidDomains);

        if (preg_match('/'.$domainsRegexp.'/', $value)) {
            $this->context->buildViolation($constraint->message)
                 ->setParameter('%string%', $value)
                 ->addViolation();
        }
    }
}
